summaryrefslogtreecommitdiff
path: root/.config/lf
diff options
context:
space:
mode:
authorBenjamin Chausse <benjamin@chausse.xyz>2025-03-30 01:00:51 -0400
committerBenjamin Chausse <benjamin@chausse.xyz>2025-03-30 01:00:51 -0400
commitf4c4550e327d9090c82a735d39d104d0bedb602d (patch)
treefcfa762512155c132a66d3adbb56067ca2d5d61b /.config/lf
parent43dbb32d741e11f8e06341f515944ec757d4578f (diff)
Loads of laptop shit
Diffstat (limited to '.config/lf')
-rwxr-xr-x.config/lf/clean3
-rwxr-xr-x.config/lf/cleaner4
-rwxr-xr-x.config/lf/kitty.sh44
-rwxr-xr-x.config/lf/lfrc30
-rwxr-xr-x.config/lf/preview68
-rwxr-xr-x.config/lf/scope29
6 files changed, 139 insertions, 39 deletions
diff --git a/.config/lf/clean b/.config/lf/clean
new file mode 100755
index 0000000..4bbbaf1
--- /dev/null
+++ b/.config/lf/clean
@@ -0,0 +1,3 @@
+#!/bin/bash
+
+$XDG_CONFIG_HOME/lf/kitty.sh delete_img $LF_KITTY_IMAGE_ID 0
diff --git a/.config/lf/cleaner b/.config/lf/cleaner
deleted file mode 100755
index a184d84..0000000
--- a/.config/lf/cleaner
+++ /dev/null
@@ -1,4 +0,0 @@
-#!/bin/sh
-if [ -n "$FIFO_UEBERZUG" ]; then
- printf '{"action": "remove", "identifier": "PREVIEW"}\n' > "$FIFO_UEBERZUG"
-fi
diff --git a/.config/lf/kitty.sh b/.config/lf/kitty.sh
new file mode 100755
index 0000000..fa84b3f
--- /dev/null
+++ b/.config/lf/kitty.sh
@@ -0,0 +1,44 @@
+#!/bin/bash
+
+# Transmits an image in png format via file-mode transmission.
+# $1 file path
+# $2 image id
+transmit_file_png() {
+ abspath_b64="$(printf -- "$(realpath -- "$1")" | base64 -w0)"
+ printf "\e_Gt=f,i=$2,f=100,q=1;$abspath_b64\e\\" >/dev/tty
+}
+
+# Displays an already transferred image.
+# $1 image id
+# $2 placement id
+# $3 x, $4 y, $5 w, $6 h
+display_img() {
+ printf "\e[s" >/dev/tty # save cursor position
+ tput cup $4 $3 >/dev/tty # move cursor
+ printf "\e_Ga=p,i=$1,p=$2,q=1\e\\" >/dev/tty
+ printf "\e[u" >/dev/tty # restore cursor position
+}
+
+# Deletes a displayed image.
+# $1 image id
+# $2 placement id
+delete_img() {
+ printf "\e_Ga=d,d=I,i=$1,p=$2,q=1\e\\" >/dev/tty
+}
+
+# Combines transmit_file_png and display_img.
+# $1 file path
+# $2 image id
+# $3 placement id
+# $4 x, $5 y, $6 w, $7 h
+show() {
+ local img_width img_height new_width new_height
+ img_width=$(identify -format "%w" "$1")
+ img_height=$(identify -format "%h" "$1")
+ new_width=$6
+ new_height=$7
+ transmit_file_png "$1" "$2"
+ display_img "$2" "$3" "$4" "$5" "$new_width" "$new_height"
+}
+
+"$@"
diff --git a/.config/lf/lfrc b/.config/lf/lfrc
index fe28549..48a5d0d 100755
--- a/.config/lf/lfrc
+++ b/.config/lf/lfrc
@@ -1,20 +1,3 @@
-# Luke's lf settings
-
-
-# Note on Image Previews
-# For those wanting image previews, like this system, there are four steps to
-# set it up. These are done automatically for LARBS users, but I will state
-# them here for others doing it manually.
-#
-# 1. ueberzug must be installed.
-# 2. The scope file (~/.config/lf/scope for me), must have a command similar to
-# mine to generate ueberzug images.
-# 3. A `set cleaner` line as below is a cleaner script.
-# 4. lf should be started through a wrapper script (~/.local/bin/lfub for me)
-# that creates the environment for ueberzug. This command can be be aliased
-# in your shellrc (`alias lf="lfub") or if set to a binding, should be
-# called directly instead of normal lf.
-
# Basic vars
set sixel true
set shellopts '-eu'
@@ -23,10 +6,11 @@ set scrolloff 10
set icons
set period 1
set hiddenfiles ".*:*.aux:*.log:*.bbl:*.bcf:*.blg:*.run.xml:tags:*.org_archive"
-set cleaner '~/.config/lf/cleaner'
-set previewer '~/.config/lf/scope'
set autoquit true
+set previewer '~/.config/lf/preview'
+set cleaner '~/.config/lf/clean'
+
# cmds/functions
cmd open ${{
case $(file --mime-type "$(readlink -f $f)" -b) in
@@ -75,7 +59,7 @@ cmd moveto ${{
clear; tput cup $(($(tput lines)/3)); tput bold
set -f
clear; echo "Move to where?"
- dest="$(sed -e 's/\s*#.*//' -e '/^$/d' -e 's/^\S*\s*//' ${XDG_CONFIG_HOME:-$HOME/.config}/shell/bm-dirs | fzf | sed 's|~|$HOME|')" &&
+ dest="$(fzf-shortcuts)" &&
for x in $fx; do
eval mv -iv \"$x\" \"$dest\"
done &&
@@ -117,8 +101,6 @@ cmd bulkrename ${{
}}
# Bindings
-map <c-f> $lf -remote "send $id select \"$(fzf)\""
-map J $lf -remote "send $id cd $(sed -e 's/\s*#.*//' -e '/^$/d' -e 's/^\S*\s*//' ${XDG_CONFIG_HOME:-$HOME/.config}/shell/bm-dirs | fzf)"
map D delete
map <c-n> push :mkdir<space>
map <c-r> reload
@@ -143,10 +125,10 @@ map V push :!nvim<space>
map N push :!touch<space>
map W $setsid -f $TERMINAL >/dev/null 2>&1
-map Y $printf "%s" "$fx" | xclip -selection clipboard
+map Y $printf "%s" "$fx" | wl-copy
map E $dropbox-cli exclude add "$f" && notify-send -a " Dropbox" "Excluded $f from computer"
map R $dropbox-restore "$f"
-map S $dropbox-cli sharelink "$f" | xsel -b && notify-send -a " Dropbox" "Link copied to clipboard."
+map S $dropbox-cli sharelink "$f" | wl-copy && notify-send -a " Dropbox" "Link copied to clipboard."
# Source Bookmarks
source "~/.config/lf/shortcuts"
diff --git a/.config/lf/preview b/.config/lf/preview
new file mode 100755
index 0000000..635edc9
--- /dev/null
+++ b/.config/lf/preview
@@ -0,0 +1,68 @@
+#!/bin/bash
+
+set -C -f
+IFS="$(printf '%b_' '\n')"
+IFS="${IFS%_}"
+
+# Called by lf to generate the preview.
+# $1 file path
+# $4 x offset in cell coordinates
+# $5 y offset in cell coordinates
+# $2 width of the display area in cell coordinates
+# $3 height of the display area in cell coordinates
+THUMBNAIL_FPATH="$LF_KITTY_TEMPDIR/thumbnail.png"
+
+# case "$(basename -- "$1" | tr '[:upper:]' '[:lower:]')" in
+case "$(file --dereference --brief --mime-type -- "$1")" in
+text/html)
+ lynx -width="$4" -display_charset=utf-8 -dump "$1"
+ ;;
+text/troff)
+ w=`expr "$2" - 2`
+ MANWIDTH="$w" man ./ "$1"
+ ;;
+text/* | */xml)
+ [ "${1##*.}" = "md" ] && glow -s dark -w "$2" "$1" && exit 0
+ bat --terminal-width "$(($4 - 2))" -f "$1"
+ ;;
+application/json | application/x-ndjson)
+ jq -C < "$1" ;;
+audio/* | application/octet-stream)
+ mediainfo "$1" || exit 1
+ ;;
+image/png)
+ $XDG_CONFIG_HOME/lf/kitty.sh show "$1" $LF_KITTY_IMAGE_ID 1 $4 $5 $2 $3
+ ;;
+image/gif)
+ magick convert "${1}[0]" "$THUMBNAIL_FPATH"
+ $XDG_CONFIG_HOME/lf/kitty.sh show "$THUMBNAIL_FPATH" $LF_KITTY_IMAGE_ID 1 $4 $5 $2 $3
+ ;;
+image/*)
+ magick convert "$1" "$THUMBNAIL_FPATH"
+ $XDG_CONFIG_HOME/lf/kitty.sh show "$THUMBNAIL_FPATH" $LF_KITTY_IMAGE_ID 1 $4 $5 $2 $3
+ ;;
+application/pdf)
+ gs -o "$THUMBNAIL_FPATH" -sDEVICE=pngalpha -dLastPage=1 "$1" >/dev/null
+ $XDG_CONFIG_HOME/lf/kitty.sh show "$THUMBNAIL_FPATH" $LF_KITTY_IMAGE_ID 1 $4 $5 $2 $3
+ ;;
+font/* | application/vnd.ms-opentype)
+ FONT_NAME=$(fc-query --format "%{family}\n" "$1" | head -n 1)
+
+ PREVIEW_TEXT="${FONT_NAME}\nABCDEFGHIJKLMNOPQRSTUBWXYZ\n""\
+abcdefghijklmnopqrstuvwxyz\n""\
+1234567890\n""\
+!@#$\%(){}[]-+=_\`~"
+
+ magick convert -size "1920x1080" xc:'#ffffff' \
+ -gravity center -pointsize 76 \
+ -font "$1" \
+ -fill '#000000' \
+ -annotate +0+0 "$PREVIEW_TEXT" \
+ "$THUMBNAIL_FPATH"
+ $XDG_CONFIG_HOME/lf/kitty.sh show "$THUMBNAIL_FPATH" $LF_KITTY_IMAGE_ID 1 $4 $5 $2 $3
+ ;;
+*)
+ cat "$1"
+ ;;
+esac
+exit 127
diff --git a/.config/lf/scope b/.config/lf/scope
index e2a77f7..d28177d 100755
--- a/.config/lf/scope
+++ b/.config/lf/scope
@@ -8,7 +8,7 @@ PREVIEW_DIR="${XDG_CACHE_HOME:-$HOME/.cache}/lf"
PREVIEW_WIDTH=600 # px
chafafunc() {
- chafa -f sixel -O 0 --polite on -c full --color-space din99d -w 9 -t 0.8 --size "$1"x
+ chafa -f sixel -O 0 --polite on -c full -w 9 -t 0.8 --view-size "$1"x"$2" --animate false --fg-only
}
# Prevent recursive thumbnails (if the file ends in .six)
@@ -19,16 +19,22 @@ text/html)
lynx -width="$4" -display_charset=utf-8 -dump "$1"
;;
text/troff)
- man ./ "$1" | col -b
+ w=`expr "$2" - 2`
+ MANWIDTH="$w" man ./ "$1"
;;
-text/* | */xml | application/json | application/x-ndjson)
+text/* | */xml)
+ [ "${1##*.}" = "md" ] && glow -s dark -w "$2" "$1" && exit 0
bat --terminal-width "$(($4 - 2))" -f "$1"
;;
+application/json | application/x-ndjson)
+ jq -C < "$1" ;;
audio/* | application/octet-stream)
mediainfo "$1" || exit 1
;;
font/* | application/vnd.ms-opentype)
- PREVIEW_TEXT="ABCDEFGHIJKLMNOPQRSTUBWXYZ\n""\
+ FONT_NAME=$(fc-query --format "%{family}\n" "$1" | head -n 1)
+
+ PREVIEW_TEXT="${FONT_NAME}\nABCDEFGHIJKLMNOPQRSTUBWXYZ\n""\
abcdefghijklmnopqrstuvwxyz\n""\
1234567890\n""\
!@#$\%(){}[]-+=_\`~"
@@ -38,26 +44,27 @@ abcdefghijklmnopqrstuvwxyz\n""\
-font "$1" \
-fill '#000000' \
-annotate +0+0 "$PREVIEW_TEXT" \
- -flatten jpeg:- | chafafunc $2
+ -flatten jpeg:- | chafafunc $2 $3
;;
+
image/vnd.djvu)
djvused "$1" -e 'select 1; save-page-with /dev/stdout' |
- convert djvu:- jpeg:- | chafafunc $2
+ convert djvu:- jpeg:- | chafafunc $2 $3
;;
image/webp)
- dwebp "$1" -tiff -o - | chafafunc $2
+ dwebp "$1" -tiff -o - | chafafunc $2 $3
;;
image/heic)
- convert "$1" jpeg:- | chafafunc $2
+ convert "$1" jpeg:- | chafafunc $2 $3
;;
image/*)
- cat "$1" | chafafunc $2
+ cat "$1" | chafafunc $2 $3
;;
*/pdf)
- pdftocairo -singlefile -scale-to-x $PREVIEW_WIDTH -scale-to-y -1 -jpeg "$1" - | chafafunc $2
+ pdftocairo -singlefile -scale-to-x $PREVIEW_WIDTH -scale-to-y -1 -jpeg "$1" - | chafafunc $2 $3
;;
video/*)
- ffmpegthumbnailer -i "$1" -s 0 -c jpeg -f -o - | chafafunc $2
+ ffmpegthumbnailer -i "$1" -s 0 -c jpeg -f -o - | chafafunc $2 $3
;;
application/*zip)
atool --list -- "$1"